Description

When using SwiftMailer the ProxyClassBuilder creates following code in F3_SwiftMailer_Message.php:

1private function FLOW3_Proxy_injectProperties() {
2    $this->mailer = new \F3\SwiftMailer\Mailer(X);
3}

This obviously leads to an exception here.
I got this fixed by changing line 99 of the ProxyClassBuilder from

1$preparedArguments[] = 'X';

to

1$preparedArguments[] = '\F3\FLOW3\Core\Bootstrap::$staticObjectManager->get(\'' . $argumentValue . '\')';

Additionally I needed to add following lines to the beginning of the ObjectManager::create() method:

1if (isset($this->objects[$objectName]['f'])) {
2    return $this->buildObjectByFactory($objectName);
3}

Not sure, if that is a clean solution, but it seems to fix the issue for me.

Related issues:
related to TYPO3.Flow - Bug # 10595: ObjectManager should not allow injection... Rejected 2010-11-02
duplicates TYPO3.Flow - Bug # 25448: Use of undefined constant 'X' during pro... Closed 2011-03-30
Revision feff686a - 2011-05-03 16:47 - Bastian Waidelich

[BUGFIX] ProxyClassBuilder produces valid code for prototype arguments

Currently FLOW3 does not support the injection of prototype objects
that require constructor arguments. Instead the ProxyClassBuilder
statically inserts "X" as constructor argument.

Change-Id: I5650866cc2aa117dc580d16867a5e9a686d0c1f2
Resolves: #25908

History
#1 - 2011-04-12 12:17 - Karsten Dambekalns
- Status changed from New to Closed

Duplicate with nicer description provided by Bastian :)

#2 - 2011-04-12 12:34 - Bastian Waidelich
- Status changed from Closed to New

Karsten Dambekalns wrote:

Duplicate with nicer description provided by Bastian :)

sorry for the duplicate, but at least one of the issues should stay open *g

#3 - 2011-05-02 18:22 - Mr. Hudson

Patch set 1 of change I5650866cc2aa117dc580d16867a5e9a686d0c1f2 has been pushed to the review server.
It is available at http://review.typo3.org/1830

#4 - 2011-05-03 16:47 - Mr. Hudson

Patch set 2 of change I5650866cc2aa117dc580d16867a5e9a686d0c1f2 has been pushed to the review server.
It is available at http://review.typo3.org/1830

#5 - 2011-05-03 17:00 - Bastian Waidelich
- Status changed from New to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:feff686a2e3095188794baedd72bb17a493f45be.
